variables:
  TF_DIR: ${CI_PROJECT_DIR}

stages:
  - validate
  - plan
  - apply

image:
  name: lalitjoshi/my-cicd-iamge:v1.0
  entrypoint: [""]

before_script:
  - terraform --version
  - export GITLAB_ACCESS_TOKEN=$TOKEN
  - gcloud auth activate-service-account --key-file=${SERVICE_ACCOUNT_KEY}
  - pushd ${TF_DIR}
  - terraform init

validate:
  stage: validate
  script:
    - terraform validate
  #tags: [windowslaptop]
  
plan:
  stage: plan 
  script:
    - terraform plan -out "$CI_PROJECT_DIR/appA-dev.plan"
  artifacts:
    untracked: false
    when: on_success
    expire_in: "1 week"
    paths:
      - $CI_PROJECT_DIR/appA-dev.plan
  dependencies:
    - validate
  #tags: [windowslaptop]

apply:
  stage: apply
  script:
    - terraform apply -auto-approve "$CI_PROJECT_DIR/appA-dev.plan"
  dependencies:
    - plan
  when: manual
  only:
    refs:
      - main
  #tags: [windowslaptop]

